from typing import List
import ghidra.app.util.cparser.C
import ghidra.program.model.data
import java.io
import java.lang
import java.util


class CParser(object, ghidra.app.util.cparser.C.CParserConstants):
    ASM: int = 45
    ASMBLOCK: int = 1
    ASMBLOCKB: int = 80
    ASMBLOCKP: int = 81
    ASM_SEMI: int = 82
    ATTRIBUTE: int = 42
    AUTO: int = 61
    BREAK: int = 33
    CASE: int = 50
    CDECL: int = 36
    CHAR: int = 63
    CHARACTER_LITERAL: int = 15
    CONST: int = 35
    CONTINUE: int = 17
    DECIMAL_LITERAL: int = 10
    DECLSPEC: int = 37
    DEFAULT: int = 0
    DFLT: int = 22
    DIGIT: int = 77
    DO: int = 70
    DOUBLE: int = 23
    ELSE: int = 49
    ENUM: int = 60
    EOF: int = 0
    EXPONENT: int = 14
    EXTENSION: int = 43
    EXTERN: int = 27
    FAR: int = 66
    FASTCALL: int = 41
    FLOAT: int = 47
    FLOATING_POINT_LITERAL: int = 13
    FOR: int = 67
    GOTO: int = 64
    HEX_LITERAL: int = 11
    IDENTIFIER: int = 75
    IF: int = 69
    INLINE: int = 46
    INT: int = 68
    INT16: int = 53
    INT32: int = 54
    INT64: int = 55
    INT8: int = 52
    INTEGER_LITERAL: int = 9
    INTERFACE: int = 72
    LETTER: int = 76
    LINE: int = 73
    LINEALT: int = 74
    LINEBLOCK: int = 2
    LINENUMBER_LITERAL: int = 88
    LONG: int = 51
    NEAR: int = 65
    OBJC: int = 4
    OBJC2: int = 5
    OBJC2_END: int = 131
    OBJC2_IGNORE: int = 130
    OBJC_DIGIT: int = 118
    OBJC_IDENTIFIER: int = 116
    OBJC_IGNORE: int = 115
    OBJC_LETTER: int = 117
    OBJC_SEMI: int = 119
    OCTAL_LITERAL: int = 12
    PATH_LITERAL: int = 87
    PCLOSE: int = 101
    PCOLON: int = 103
    PCOMMA: int = 104
    PDECIMAL_LITERAL: int = 106
    PDIGIT: int = 99
    PHASH: int = 102
    PHEX_LITERAL: int = 107
    PIDENTIFIER: int = 97
    PINTEGER_LITERAL: int = 105
    PLETTER: int = 98
    POCTAL_LITERAL: int = 108
    POPEN: int = 100
    PRAGMA: int = 38
    PRAGMALINE: int = 3
    PROTOCOL: int = 71
    PSTRING_LITERAL: int = 109
    PTR32: int = 57
    PTR64: int = 56
    QUOTE_C: int = 28
    READABLETO: int = 39
    REGISTER: int = 19
    RESTRICT: int = 44
    RETURN: int = 26
    SHORT: int = 48
    SIGNED: int = 31
    SIZEOF: int = 24
    STATIC: int = 30
    STDCALL: int = 40
    STRING_LITERAL: int = 16
    STRUCT: int = 29
    SWITCH: int = 25
    TYPEDEF: int = 21
    UNION: int = 34
    UNSIGNED: int = 20
    VOID: int = 62
    VOLATILE: int = 18
    W64: int = 58
    WCHAR: int = 59
    WHILE: int = 32
    jj_nt: ghidra.app.util.cparser.C.Token
    token: ghidra.app.util.cparser.C.Token
    tokenImage: List[unicode] = array(java.lang.String, [u'<EOF>', u'" "', u'"\\f"', u'"\\t"', u'"\\n"', u'"\\r"', u'"\\\\"', u'<token of kind 7>', u'<token of kind 8>', u'<INTEGER_LITERAL>', u'<DECIMAL_LITERAL>', u'<HEX_LITERAL>', u'<OCTAL_LITERAL>', u'<FLOATING_POINT_LITERAL>', u'<EXPONENT>', u'<CHARACTER_LITERAL>', u'<STRING_LITERAL>', u'"continue"', u'<VOLATILE>', u'"register"', u'"unsigned"', u'"typedef"', u'"default"', u'"double"', u'"sizeof"', u'"switch"', u'"return"', u'"extern"', u'"\\"C\\""', u'"struct"', u'"static"', u'<SIGNED>', u'"while"', u'"break"', u'"union"', u'<CONST>', u'<CDECL>', u'"__declspec"', u'<PRAGMA>', u'"__readableTo"', u'<STDCALL>', u'<FASTCALL>', u'<ATTRIBUTE>', u'<EXTENSION>', u'<RESTRICT>', u'<ASM>', u'<INLINE>', u'"float"', u'"short"', u'"else"', u'"case"', u'"long"', u'"__int8"', u'"__int16"', u'"__int32"', u'"__int64"', u'"__ptr64"', u'"__ptr32"', u'"__w64"', u'"wchar_t"', u'"enum"', u'"auto"', u'"void"', u'"char"', u'"goto"', u'"near"', u'"far"', u'"for"', u'"int"', u'"if"', u'"do"', u'"@protocol"', u'"@interface"', u'"#line"', u'<LINEALT>', u'<IDENTIFIER>', u'<LETTER>', u'<DIGIT>', u'" "', u'"\\t"', u'<ASMBLOCKB>', u'<ASMBLOCKP>', u'<ASM_SEMI>', u'" "', u'"\\f"', u'"\\t"', u'":"', u'<PATH_LITERAL>', u'<LINENUMBER_LITERAL>', u'" "', u'"\\f"', u'"\\t"', u'"\\n"', u'"\\r"', u'";"', u'<token of kind 95>', u'<token of kind 96>', u'<PIDENTIFIER>', u'<PLETTER>', u'<PDIGIT>', u'"("', u'")"', u'"#"', u'":"', u'","', u'<PINTEGER_LITERAL>', u'<PDECIMAL_LITERAL>', u'<PHEX_LITERAL>', u'<POCTAL_LITERAL>', u'<PSTRING_LITERAL>', u'" "', u'"\\f"', u'"\\t"', u'"\\n"', u'"\\r"', u'<OBJC_IGNORE>', u'<OBJC_IDENTIFIER>', u'<OBJC_LETTER>', u'<OBJC_DIGIT>', u'<OBJC_SEMI>', u'" "', u'"\\f"', u'"\\t"', u'"\\n"', u'"\\r"', u'"@private"', u'"@protected"', u'"@property"', u'"@optional"', u'"@required"', u'<OBJC2_IGNORE>', u'"@end"', u'";"', u'"("', u'")"', u'","', u'":"', u'"#"', u'"{"', u'"}"', u'"="', u'"["', u'"]"', u'"*"', u'"&"', u'"..."', u'"+"', u'"-"', u'"*="', u'"/="', u'"%="', u'"+="', u'"-="', u'"<<="', u'">>="', u'"&="', u'"^="', u'"|="', u'"?"', u'"||"', u'"&&"', u'"|"', u'"^"', u'"=="', u'"!="', u'"<"', u'">"', u'"<="', u'">="', u'"<<"', u'">>"', u'"/"', u'"%"', u'"++"', u'"--"', u'"~"', u'"!"', u'"."', u'"->"'])
    token_source: ghidra.app.util.cparser.C.CParserTokenManager



    @overload
    def __init__(self): ...

    @overload
    def __init__(self, __a0: ghidra.app.util.cparser.C.CParserTokenManager): ...

    @overload
    def __init__(self, __a0: ghidra.program.model.data.DataTypeManager): ...

    @overload
    def __init__(self, __a0: java.io.InputStream): ...

    @overload
    def __init__(self, __a0: java.io.Reader): ...

    @overload
    def __init__(self, __a0: java.io.InputStream, __a1: unicode): ...

    @overload
    def __init__(self, __a0: ghidra.program.model.data.DataTypeManager, __a1: bool, __a2: List[ghidra.program.model.data.DataTypeManager]): ...



    def ANDExpression(self) -> object: ...

    def AbstractDeclarator(self, __a0: ghidra.app.util.cparser.C.Declaration) -> ghidra.app.util.cparser.C.Declaration: ...

    def AdditiveExpression(self) -> object: ...

    def ArgumentExpressionList(self) -> None: ...

    def AsmLine(self) -> None: ...

    def AsmStatement(self) -> None: ...

    def AssignmentExpression(self) -> object: ...

    def AssignmentOperator(self) -> None: ...

    def AttributeSpec(self) -> None: ...

    def AttributeSpecList(self) -> None: ...

    def BuiltInDeclarationSpecifier(self, __a0: ghidra.app.util.cparser.C.Declaration) -> ghidra.app.util.cparser.C.Declaration: ...

    def BuiltInTypeSpecifier(self, __a0: ghidra.app.util.cparser.C.Declaration) -> ghidra.app.util.cparser.C.Declaration: ...

    def CastExpression(self) -> object: ...

    def CompoundStatement(self) -> None: ...

    def ConditionalExpression(self) -> object: ...

    def Constant(self) -> object: ...

    def ConstantExpression(self) -> object: ...

    def DeclConstant(self) -> None: ...

    def DeclSpec(self) -> None: ...

    def DeclSpecifier(self) -> None: ...

    def Declaration(self) -> ghidra.app.util.cparser.C.Declaration: ...

    def DeclarationList(self) -> None: ...

    def DeclarationSpecifiers(self, __a0: ghidra.app.util.cparser.C.Declaration) -> ghidra.app.util.cparser.C.Declaration: ...

    def Declarator(self, __a0: ghidra.app.util.cparser.C.Declaration, __a1: ghidra.program.model.data.DataType) -> ghidra.app.util.cparser.C.Declaration: ...

    def DirectAbstractDeclarator(self, __a0: ghidra.app.util.cparser.C.Declaration) -> ghidra.app.util.cparser.C.Declaration: ...

    def DirectDeclarator(self, __a0: ghidra.app.util.cparser.C.Declaration, __a1: ghidra.program.model.data.DataType) -> ghidra.app.util.cparser.C.Declaration: ...

    def EnumSpecifier(self) -> ghidra.program.model.data.DataType: ...

    def Enumerator(self, __a0: java.util.ArrayList, __a1: int) -> int: ...

    def EnumeratorList(self) -> java.util.ArrayList: ...

    def EqualityExpression(self) -> object: ...

    def ExclusiveORExpression(self) -> object: ...

    def Expression(self) -> object: ...

    def ExpressionStatement(self) -> None: ...

    def ExternalDeclaration(self) -> None: ...

    def FunctionDefinition(self) -> None: ...

    def IdentifierList(self, __a0: ghidra.program.model.data.FunctionDefinitionDataType, __a1: ghidra.program.model.data.DataType) -> None: ...

    def InclusiveORExpression(self) -> object: ...

    def InitDeclarator(self, __a0: ghidra.app.util.cparser.C.Declaration) -> None: ...

    def InitDeclaratorList(self, __a0: ghidra.app.util.cparser.C.Declaration) -> None: ...

    def Initializer(self) -> None: ...

    def InitializerList(self) -> None: ...

    def IterationStatement(self) -> None: ...

    def JumpStatement(self) -> None: ...

    def LabeledStatement(self) -> None: ...

    def LineDef(self) -> None: ...

    def LogicalANDExpression(self) -> object: ...

    def LogicalORExpression(self) -> object: ...

    def MultiplicativeExpression(self) -> object: ...

    def ObjcDef(self) -> ghidra.program.model.data.DataType: ...

    def ParameterDeclaration(self, __a0: java.util.ArrayList) -> None: ...

    def ParameterList(self) -> java.util.ArrayList: ...

    def ParameterTypeList(self, __a0: ghidra.program.model.data.FunctionDefinitionDataType, __a1: ghidra.program.model.data.DataType) -> ghidra.app.util.cparser.C.Declaration: ...

    def Pointer(self, __a0: ghidra.app.util.cparser.C.Declaration) -> ghidra.app.util.cparser.C.Declaration: ...

    def PostfixExpression(self) -> object: ...

    def PragmaConstant(self) -> ghidra.app.util.cparser.C.Token: ...

    def PragmaSpec(self) -> None: ...

    def PragmaSpecifier(self) -> None: ...

    def PrimaryExpression(self) -> object: ...

    @overload
    def ReInit(self, __a0: ghidra.app.util.cparser.C.CParserTokenManager) -> None: ...

    @overload
    def ReInit(self, __a0: java.io.InputStream) -> None: ...

    @overload
    def ReInit(self, __a0: java.io.Reader) -> None: ...

    @overload
    def ReInit(self, __a0: java.io.InputStream, __a1: unicode) -> None: ...

    def RelationalExpression(self) -> object: ...

    def SelectionStatement(self) -> None: ...

    def ShiftExpression(self) -> object: ...

    def SpecifierQualifierList(self) -> ghidra.app.util.cparser.C.Declaration: ...

    def Statement(self) -> None: ...

    def StatementList(self) -> None: ...

    def StorageClassSpecifier(self, __a0: ghidra.app.util.cparser.C.Declaration) -> ghidra.app.util.cparser.C.Declaration: ...

    def StructDeclaration(self, __a0: ghidra.program.model.data.Composite, __a1: ghidra.app.util.cparser.C.CompositeHandler) -> None: ...

    def StructDeclarationList(self, __a0: ghidra.program.model.data.Composite) -> None: ...

    def StructDeclarator(self, __a0: ghidra.app.util.cparser.C.Declaration, __a1: ghidra.program.model.data.Composite, __a2: ghidra.app.util.cparser.C.CompositeHandler) -> None: ...

    def StructDeclaratorList(self, __a0: ghidra.app.util.cparser.C.Declaration, __a1: ghidra.program.model.data.Composite, __a2: ghidra.app.util.cparser.C.CompositeHandler) -> None: ...

    def StructOrUnion(self) -> ghidra.program.model.data.Composite: ...

    def StructOrUnionSpecifier(self) -> ghidra.program.model.data.DataType: ...

    def SubIdent(self) -> None: ...

    def TranslationUnit(self) -> None: ...

    def TypeName(self) -> ghidra.program.model.data.DataType: ...

    def TypeQualifier(self, __a0: ghidra.app.util.cparser.C.Declaration) -> ghidra.app.util.cparser.C.Declaration: ...

    def TypeQualifierList(self, __a0: ghidra.app.util.cparser.C.Declaration) -> ghidra.app.util.cparser.C.Declaration: ...

    def TypeSpecifier(self, __a0: ghidra.app.util.cparser.C.Declaration) -> ghidra.app.util.cparser.C.Declaration: ...

    def TypedefName(self) -> ghidra.program.model.data.DataType: ...

    def UnaryExpression(self) -> object: ...

    def UnaryOperator(self) -> None: ...

    def disable_tracing(self) -> None: ...

    def enable_tracing(self) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def generateParseException(self) -> ghidra.app.util.cparser.C.ParseException: ...

    def getClass(self) -> java.lang.Class: ...

    def getDataTypeManager(self) -> ghidra.program.model.data.DataTypeManager: ...

    def getDeclarations(self) -> java.util.Map: ...

    def getEnums(self) -> java.util.Map: ...

    def getFunctions(self) -> java.util.Map: ...

    def getLastDataType(self) -> ghidra.program.model.data.DataType: ...

    def getNextToken(self) -> ghidra.app.util.cparser.C.Token: ...

    def getStructs(self) -> java.util.Map: ...

    def getToken(self, __a0: int) -> ghidra.app.util.cparser.C.Token: ...

    def getTypes(self) -> java.util.Map: ...

    def hashCode(self) -> int: ...

    @staticmethod
    def main(__a0: List[unicode]) -> None: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    @overload
    def parse(self, __a0: unicode) -> ghidra.program.model.data.DataType: ...

    @overload
    def parse(self, __a0: java.io.InputStream) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def dataTypeManager(self) -> ghidra.program.model.data.DataTypeManager: ...

    @property
    def declarations(self) -> java.util.Map: ...

    @property
    def enums(self) -> java.util.Map: ...

    @property
    def functions(self) -> java.util.Map: ...

    @property
    def lastDataType(self) -> ghidra.program.model.data.DataType: ...

    @property
    def nextToken(self) -> ghidra.app.util.cparser.C.Token: ...

    @property
    def structs(self) -> java.util.Map: ...

    @property
    def types(self) -> java.util.Map: ...