from typing import List
import ghidra.app.util.bin
import ghidra.program.model.data
import java.lang


class ISO9660PathTable(object, ghidra.app.util.bin.StructConverter):
    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = ImageBaseOffset32
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    STRING: ghidra.program.model.data.DataType = string
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word



    def __init__(self, __a0: ghidra.app.util.bin.BinaryReader, __a1: bool): ...



    def equals(self, __a0: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    def getDirIdentifierLength(self) -> int: ...

    def getDirectoryIdentifier(self) -> List[int]: ...

    def getDirectoryNumberPathIndex(self) -> int: ...

    def getExtendedAttributeRecordLength(self) -> int: ...

    def getLocationOfExtent(self) -> int: ...

    def getPaddingField(self) -> int: ...

    def getVolumeIndex(self) -> long: ...

    def hashCode(self) -> int: ...

    def isLittleEndian(self) -> bool: ...

    def isPaddingFieldPresent(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def dirIdentifierLength(self) -> int: ...

    @property
    def directoryIdentifier(self) -> List[int]: ...

    @property
    def directoryNumberPathIndex(self) -> int: ...

    @property
    def extendedAttributeRecordLength(self) -> int: ...

    @property
    def littleEndian(self) -> bool: ...

    @property
    def locationOfExtent(self) -> int: ...

    @property
    def paddingField(self) -> int: ...

    @property
    def paddingFieldPresent(self) -> bool: ...

    @property
    def volumeIndex(self) -> long: ...